package nl.sbdeveloper.themeparkplus.listeners;

import nl.iobyte.themepark.api.attraction.component.Status;
import nl.iobyte.themepark.api.attraction.manager.StatusManager;
import nl.iobyte.themepark.api.events.attraction.ChangeStatusEvent;
import nl.sbdeveloper.themeparkplus.ThemeParkPlus;
import nl.sbdeveloper.themeparkplus.util.ConfigUtil;
import nl.sbdeveloper.themeparkplus.util.DiscordWebhook;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.awt.*;
import java.io.IOException;

/**
 * Status change listener for discord webhook
 */
public class StatusChangeListener implements Listener {
    @EventHandler
    public void onStatusChange(@NotNull ChangeStatusEvent e) {
        if (e.getAfter() != Status.GLOBAL) {
            String title = ThemeParkPlus.getSConfig().getFile().getString("DiscordWebhook.Embed.Title");
            if (title == null) return;

            String rideName = ChatColor.stripColor(ConfigUtil.makecolored(e.getAttraction().getName()));
            String regionName = ChatColor.stripColor(ConfigUtil.makecolored(e.getAttraction().getRegion().getName()));
            String statusAfter = ChatColor.stripColor(ConfigUtil.makecolored(StatusManager.getName(e.getAfter())));

            title = title.replaceAll("%RideName%", rideName);
            title = title.replaceAll("%Region%", regionName);
            String copy = ThemeParkPlus.getSConfig().getFile().getString("DiscordWebhook.Embed.Copyright");
            String copyimg = ThemeParkPlus.getSConfig().getFile().getString("DiscordWebhook.Embed.CopyrightImage");
            Color color = new Color(ThemeParkPlus.getSConfig().getFile().getInt("DiscordWebhook.Embed.Colors." + e.getAfter().toString()));
            if (copy == null || copyimg == null) return;

            DiscordWebhook webhook = new DiscordWebhook(ThemeParkPlus.getWebhookURL());

            DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                .setTitle(title)
                .setFooter(copy, copyimg)
                .setColor(color)
                .addField(rideName, statusAfter, false);

            webhook.addEmbed(embed);
            try {
                webhook.execute();
            } catch (IOException ex) {
                Bukkit.getLogger().severe("[ThemeParkPlus] Could not send the status update to Discord! See the error below:");
                ex.printStackTrace();
            }
        }
    }
}
