package nl.sbdeveloper.themeparkplus.util;

import nl.sbdeveloper.themeparkplus.api.enums.WalkingDirection;
import org.bukkit.block.BlockFace;
import org.jetbrains.annotations.Nullable;

public class DirectionUtil {

    @Nullable
    public static WalkingDirection getDirection(int xoud, int zoud, int xnieuw, int znieuw) {
        int changeInX = xnieuw - xoud;
        int changeInZ = znieuw - zoud;

        if (changeInZ != 0 && changeInX == 0) {
            if (changeInZ < 0) {
                return WalkingDirection.NORTH;
            } else {
                return WalkingDirection.SOUTH;
            }
        } else if (changeInX != 0 && changeInZ == 0) {
            if (changeInX < 0) {
                return WalkingDirection.WEST;
            } else {
                return WalkingDirection.EAST;
            }
        }
        return null;
    }

    public static BlockFace convertFacing(WalkingDirection dir) {
        switch (dir) {
            case WEST:
                return BlockFace.SOUTH;
            case NORTH:
                return BlockFace.WEST;
            case EAST:
                return BlockFace.NORTH;
            case SOUTH:
                return BlockFace.EAST;
            default:
                return null;
        }
    }
}
